////////////////////////////////////////////////////////////////////////////
// Rev: 2010.1 (P4JsApi 1.0 Example)
//
// NOTE: This is an example only, and should be modified to work in
// a production environment! No warranty is expressed or implied.
// Scripts should be tested thoroughly on a test server before
// using in a production environment.
//
////////////////////////////////////////////////////////////////////////////
// Copyright (c) 2010, Perforce Software, Inc.  All rights reserved.
//
// Redistribution and use in source and binary forms, with or without
// modification, are permitted provided that the following conditions are met:
//
// 1.  Redistributions of source code must retain the above copyright
//     notice, this list of conditions and the following disclaimer.
//
// 2.  Redistributions in binary form must reproduce the above copyright
//     notice, this list of conditions and the following disclaimer in the
//     documentation and/or other materials provided with the distribution.
//
// THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
// AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
// IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
// ARE DISCLAIMED. IN NO EVENT SHALL PERFORCE SOFTWARE, INC. BE LIABLE FOR ANY
// DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
// (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
// LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
// ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
// (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
// THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
////////////////////////////////////////////////////////////////////////////

var P4 = P4 || {};
P4.createCountersWidget = function() {
 try {
    var counterData = [];
    var counterStore = new Ext.data.ArrayStore({
    fields: [
      {name: 'name'},
      {name: 'value'}
    ]
  });

    P4JsApi.p4("counters", function(counters){
        var counter = 0;
        while(counters.data[counter]) {
            counterData.push([counters.data[counter].counter, counters.data[counter].value]);
            counter++;
        }
      counterStore.loadData(counterData);
    });

  return new Ext.grid.GridPanel({
    store: counterStore,
    columns: [
      {id:'name',header: 'Name', width: 50, sortable: true, dataIndex: 'name'},
      {id:'value',header: 'Value', width: 50, sortable: true, dataIndex: 'value'},
    ],
    stripeRows: true,
    width: 200,
    title:'Counters',
    autoExpandColumn: 'value',
    border:false,
    autoScroll:true,
    iconCls:'settings',
    viewConfig: {
      forceFit: true,
    }
  });
 } catch(e) {
  alert(e);
 }
}